# -*- coding: utf-8 -*-
import os
import time
import oss2
from resource import pcd_overlook_mp4
from resource import pcd_forwardlook_mp4
import logging

path1 = '/mnt/disk001/dcl_data_process/src/python2/pjisuv/'

logging.basicConfig(filename=path1 + 'log/pcd-pjisuv.log', level=logging.INFO,
                    format='%(asctime)s - %(levelname)s - %(message)s')

key1 = 'pjisuv/'
sleep_time = 60  # 每多少秒扫描一次


def parse_to_pcd_mp4(merged_bag_file_path, merged_bag_object_key1, parse_prefix_full1, local_parse_dir,
                     local_delete_list):
    try:
        logging.info('生成点云视频 %s' % merged_bag_file_path)
        local_pcd_dir_overlook, hz = pcd_overlook_mp4.parse(merged_bag_file_path, local_parse_dir)
        local_pcd_dir_forward, hz = pcd_forwardlook_mp4.parse(merged_bag_file_path, local_parse_dir)
        local_pcd_mp4_file_overlook = local_pcd_dir_overlook + '/pcd_overlook.mp4'
        local_pcd_mp4_file_forwardlook = local_pcd_dir_forward + '/pcd_forwardlook.mp4'
        oss_csv_object_key1 = parse_prefix_full1 + 'pcd_overlook_' + str(hz) + '.mp4'
        oss_csv_object_key11 = parse_prefix_full1 + 'pcd_overlook.mp4'
        oss_csv_object_key2 = parse_prefix_full1 + 'pcd_forwardlook_' + str(hz) + '.mp4'
        oss_csv_object_key21 = parse_prefix_full1 + 'pcd_forwardlook.mp4'
        local_delete_list.append(local_pcd_mp4_file_overlook)
        local_delete_list.append(local_pcd_mp4_file_forwardlook)
        bucket.put_object_from_file(oss_csv_object_key1, local_pcd_mp4_file_overlook)
        bucket.put_object_from_file(oss_csv_object_key11, local_pcd_mp4_file_overlook)
        logging.info('上传点云视频到 %s' % oss_csv_object_key1)
        bucket.put_object_from_file(oss_csv_object_key2, local_pcd_mp4_file_forwardlook)
        bucket.put_object_from_file(oss_csv_object_key21, local_pcd_mp4_file_forwardlook)
        logging.info('上传点云视频到 %s' % oss_csv_object_key2)
    except Exception as e:
        logging.exception("生成点云视频报错: %s" % str(e))
        # 删除多个文件。
        for obj in oss2.ObjectIterator(bucket, prefix=parse_prefix_full1):
            bucket.delete_object(obj.key)
        # 删除 bag包
        bucket.delete_object(merged_bag_object_key1)


# ------- 获取合并之后的bag包，解析出csv -------
if __name__ == '__main__':
    # 1 创建阿里云对象
    auth = oss2.Auth('n8glvFGS25MrLY7j', 'xZ2Fozoarpfw0z28FUhtg8cu0yDc5d')
    endpoint = 'oss-cn-beijing-gqzl-d01-a.ops.gqzl-cloud.com'
    bucket = oss2.Bucket(auth, endpoint, 'open-bucket')
    while True:
        try:
            logging.info("开始新一轮扫描")
            prefix_list = []
            # 2 获取已经上传完成的所有目录并分组
            for obj1 in oss2.ObjectIterator(bucket, prefix=key1):
                try:
                    local_delete_list = []
                    oss_delete_list = []
                    # 获取合并后的包
                    merged_bag_object_key = str(obj1.key)
                    # print(f'判断1{merged_bag_object_key}')
                    if 'data_merge' in str(obj1.key) and str(obj1.key).endswith('.bag'):
                        merged_bag_object_key_split = merged_bag_object_key.split('/')
                        merged_prefix = '/'.join(merged_bag_object_key_split[:-1])
                        parse_prefix = merged_prefix.replace('data_merge', 'data_parse')
                        parse_prefix_full = merged_bag_object_key.replace('data_merge', 'data_parse').replace('.bag',
                                                                                                              '/')
                        pcd1_done = False
                        pcd2_done = False
                        for obj2 in oss2.ObjectIterator(bucket, prefix=parse_prefix_full):
                            if 'pcd_overlook_' in str(obj2.key) and str(obj2.key).endswith('.mp4'):
                                pcd1_done = True
                            if 'pcd_forwardlook_' in str(obj2.key) and str(obj2.key).endswith('.mp4'):
                                pcd2_done = True
                        if pcd1_done and pcd2_done:
                            continue
                        logging.info('需要解析：%s' % merged_bag_object_key)
                        local_merged_bag_path = path1 + 'pcd/' + merged_bag_object_key
                        local_merged_dir = '/'.join(local_merged_bag_path.split('/')[:-1])
                        local_parse_dir = local_merged_dir.replace('data_merge', 'data_parse')
                        if not os.path.exists(local_merged_dir):
                            os.makedirs(local_merged_dir)
                        if not os.path.exists(local_parse_dir):
                            os.makedirs(local_parse_dir)
                        merged_bag_full_name = merged_bag_object_key_split[-1]
                        merged_bag_name = merged_bag_full_name.split('.')[0]
                        bucket.get_object_to_file(merged_bag_object_key, local_merged_bag_path)
                        local_delete_list.append(local_merged_bag_path)
                        parse_to_pcd_mp4(local_merged_bag_path, merged_bag_object_key, parse_prefix_full,
                                         local_parse_dir, local_delete_list)

                        # 删除本地临时文件
                        if len(local_delete_list) > 0:
                            for local_delete in local_delete_list:
                                try:
                                    os.remove(local_delete)
                                    logging.info("删除本地临时文件: %s" % local_delete)
                                except Exception as e:
                                    logging.exception("删除本地临时文件报错: %s" % str(e))
                except Exception as e:
                    logging.exception("局部异常处理: %s", str(e))
            time.sleep(sleep_time)
        except Exception as e:
            logging.exception("全局异常处理: %s", str(e))
